/**
 * @file
 * A script to generate accessible menu menus.
 */

((Drupal, drupalSettings, once) => {
  Drupal.behaviors.accessibleMenu = {
    attach(context) {
      const menuIds = Object.keys(drupalSettings.accessibleMenu.menus).map(id => `#${id}`).join(",");

      console.log("accessible-menu", menuIds, context);

      once("accessible-menu", menuIds, context).forEach(navigation => {
        const menuElement = navigation.querySelector("ul");
        const {constructor, options} = drupalSettings.accessibleMenu.menus[navigation.id];
        const MenuClass = window[constructor];

        const menu = new MenuClass({
          menuElement,
          submenuItemSelector: "li:has(ul)",
          ...options,
        });

        drupalSettings.accessibleMenu.menus[navigation.id].menu = menu;
      });
    },
  };
})(Drupal, drupalSettings, once);
